<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DateRange StructType
 * @subpackage Structs
 */
class DateRange extends AbstractStructBase
{
    /**
     * The RangeStartDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Date
     */
    public $RangeStartDate;
    /**
     * The RangeEndDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Date
     */
    public $RangeEndDate;
    /**
     * Constructor method for DateRange
     * @uses DateRange::setRangeStartDate()
     * @uses DateRange::setRangeEndDate()
     * @param \StructType\Date $rangeStartDate
     * @param \StructType\Date $rangeEndDate
     */
    public function __construct(\StructType\Date $rangeStartDate = null, \StructType\Date $rangeEndDate = null)
    {
        $this
            ->setRangeStartDate($rangeStartDate)
            ->setRangeEndDate($rangeEndDate);
    }
    /**
     * Get RangeStartDate value
     * @return \StructType\Date|null
     */
    public function getRangeStartDate()
    {
        return $this->RangeStartDate;
    }
    /**
     * Set RangeStartDate value
     * @param \StructType\Date $rangeStartDate
     * @return \StructType\DateRange
     */
    public function setRangeStartDate(\StructType\Date $rangeStartDate = null)
    {
        $this->RangeStartDate = $rangeStartDate;
        return $this;
    }
    /**
     * Get RangeEndDate value
     * @return \StructType\Date|null
     */
    public function getRangeEndDate()
    {
        return $this->RangeEndDate;
    }
    /**
     * Set RangeEndDate value
     * @param \StructType\Date $rangeEndDate
     * @return \StructType\DateRange
     */
    public function setRangeEndDate(\StructType\Date $rangeEndDate = null)
    {
        $this->RangeEndDate = $rangeEndDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DateRange
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
